// Generated from array_of_strings.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "cni_array_of_strings.h"

#define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
#define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)


define_cleaner_function (cni_array_of_strings_container *, free_cni_array_of_strings_container)

cni_array_of_strings_container
*make_cni_array_of_strings_container (yajl_val tree, const struct parser_context *ctx, parser_error *err)
{
    __auto_cleanup(free_cni_array_of_strings_container) cni_array_of_strings_container *ptr = NULL;
    size_t i, alen;
    if (tree == NULL || err == NULL || YAJL_GET_ARRAY (tree) == NULL)
      return NULL;
    *err = NULL;
    alen = YAJL_GET_ARRAY_NO_CHECK (tree)->len;
    if (alen == 0)
      return NULL;
    ptr = smart_calloc (1, 0, sizeof (cni_array_of_strings_container));
    if (ptr == NULL)
      return NULL;
    ptr->items = smart_calloc (alen, 1, sizeof(*ptr->items));
    if (ptr->items == NULL)
      return NULL;
    ptr->len = alen;


    for (i = 0; i < alen; i++)
      {
        yajl_val work = YAJL_GET_ARRAY_NO_CHECK (tree)->values[i];
        yajl_val val = work;
        if (val != NULL)
          {
            char *str = YAJL_GET_STRING (val);
            ptr->items[i] = strdup (str ? str : "");
            if (ptr->items[i] == NULL)
              {
                return NULL;
              }
          }


      }
    return move_ptr(ptr);
}


void free_cni_array_of_strings_container (cni_array_of_strings_container *ptr)
{
    size_t i;

    if (ptr == NULL)
        return;

    for (i = 0; i < ptr->len; i++)
      {
        free (ptr->items[i]);
        ptr->items[i] = NULL;

      }

    free (ptr->items);
    ptr->items = NULL;


    free (ptr);
}


yajl_gen_status gen_cni_array_of_strings_container (yajl_gen g, const cni_array_of_strings_container *ptr, const struct parser_context *ctx,
                       parser_error *err)
{
    yajl_gen_status stat;
    size_t i;

    if (ptr == NULL)
        return yajl_gen_status_ok;
    *err = NULL;


    stat = yajl_gen_array_open ((yajl_gen) g);
    if (stat != yajl_gen_status_ok)
        GEN_SET_ERROR_AND_RETURN (stat, err);
    for (i = 0; i < ptr->len; i++)
      {
        {
            stat = yajl_gen_string ((yajl_gen)g, (const unsigned char *)(ptr->items[i]), strlen (ptr->items[i]));
            if (stat != yajl_gen_status_ok)
                GEN_SET_ERROR_AND_RETURN (stat, err);


            }
      }
    stat = yajl_gen_array_close ((yajl_gen) g);


    if (ptr->len > 0 && !(ctx->options & OPT_GEN_SIMPLIFY))
        yajl_gen_config (g, yajl_gen_beautify, 1);
    if (stat != yajl_gen_status_ok)
        GEN_SET_ERROR_AND_RETURN (stat, err);
    return yajl_gen_status_ok;
}

cni_array_of_strings_container *
cni_array_of_strings_container_parse_file (const char *filename, const struct parser_context *ctx, parser_error *err)
{
    cni_array_of_strings_container *ptr = NULL;
    size_t filesize;
    __auto_free char *content = NULL;

    if (filename == NULL || err == NULL)
      return NULL;

    *err = NULL;
    content = read_file (filename, &filesize);
    if (content == NULL)
      {
        if (asprintf (err, "cannot read the file: %s", filename) < 0)
            *err = strdup ("error allocating memory");
        return NULL;
      }
    ptr = cni_array_of_strings_container_parse_data (content, ctx, err);
    return ptr;
}

cni_array_of_strings_container *
cni_array_of_strings_container_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
{
    cni_array_of_strings_container *ptr = NULL;
    size_t filesize;
    __auto_free char *content = NULL ;

    if (stream == NULL || err == NULL)
      return NULL;

    *err = NULL;
    content = fread_file (stream, &filesize);
    if (content == NULL)
      {
        *err = strdup ("cannot read the file");
        return NULL;
      }
    ptr = cni_array_of_strings_container_parse_data (content, ctx, err);
    return ptr;
}

define_cleaner_function (yajl_val, yajl_tree_free)

cni_array_of_strings_container *
cni_array_of_strings_container_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
{
    cni_array_of_strings_container *ptr = NULL;
    __auto_cleanup(yajl_tree_free) yajl_val tree = NULL;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
      return NULL;

    *err = NULL;
    if (strlen(jsondata) >= JSON_MAX_SIZE) {
        if (asprintf(err, "cannot parse the data with length exceeding %llu", JSON_MAX_SIZE) < 0) {
            *err = safe_strdup("error allocating memory");
        }
        return NULL;
    }

    if (ctx == NULL)
     ctx = (const struct parser_context *)(&tmp_ctx);

    tree = yajl_tree_parse (jsondata, errbuf, sizeof (errbuf));
    if (tree == NULL)
      {
        if (asprintf (err, "cannot parse the data: %s", errbuf) < 0)
            *err = strdup ("error allocating memory");
        return NULL;
      }
    ptr = make_cni_array_of_strings_container (tree, ctx, err);
    return ptr;
}

static void
cleanup_yajl_gen (yajl_gen g)
{
    if (!g)
      return;
    yajl_gen_clear (g);
    yajl_gen_free (g);
}

define_cleaner_function (yajl_gen, cleanup_yajl_gen)


char *
cni_array_of_strings_container_generate_json (const cni_array_of_strings_container *ptr, const struct parser_context *ctx, parser_error *err)
{
    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
      return NULL;

    *err = NULL;
    if (ctx == NULL)
        ctx = (const struct parser_context *)(&tmp_ctx);

    if (!json_gen_init(&g, ctx))
      {
        *err = strdup ("Json_gen init failed");
        return json_buf;
      }

    if (yajl_gen_status_ok != gen_cni_array_of_strings_container (g, ptr, ctx, err))
      {
        if (*err == NULL)
            *err = strdup ("Failed to generate json");
        return json_buf;
      }

    yajl_gen_get_buf (g, &gen_buf, &gen_len);
    if (gen_buf == NULL)
      {
        *err = strdup ("Error to get generated json");
        return json_buf;
      }

    json_buf = smart_calloc (gen_len, 1, 1);
    if (json_buf == NULL)
      {
        *err = strdup ("Cannot allocate memory");
        return json_buf;
      }
    (void) memcpy (json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

    return json_buf;
}
